%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Summer School StrongMAR - 2016
% Array Data Processing
% Paulo Santos 
% 29th June, 2016
% Frequency domain beamformer
% (The influence of the emitted signal frequency)
% pjsantos@ualg.pt
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%close all
clear all

f=input('frequency?'); % Hz
w0=2*pi*f;
c=1500; %sound speed m/s
f1=f;
%Parameters of receved signal 
phid=input('angle?');
phi_0=phid*pi/180; %source direction

L=10;%input('n of receivers?') 
d= 1;%%sensors spacing
l=1:L;
r(l)=[(l-1)*d];
rs=-r;
n0=sin(phi_0);% 0 cos(phi_0)];
k0=w0/c*n0; %wave vector
tau0=k0*rs; %delays

fs=750; %sample frequency
NFFT=1024;
t=0:1/fs:NFFT/fs;

for n=1:NFFT
    x(n,l)=exp(j*(w0*t(n)-tau0(l))); %received signal with delay
end 
X=fft(x); 

% figure
% plot(0:fs/NFFT:fs-1, abs(X))
% axis tight
% title('Source Frequency')  
% pause

[maxf indf]=max(X(:,1)); 
Xrs=X(indf,:);


fi=-90:90;
   for e=1:length(fi)
        %steering angle
        phi=fi(e)*pi/180;
        n=sin(phi);
        k=w0/c*n;
        tau=k*rs;
        Xss=exp(-j*tau);
	    B(e)=abs(Xrs*Xss');
        
   end

B_s=(B)/max(max(B));

figure
hold on
plot(fi,B_s,'b','lineWidth',2)
xh=xlabel('\phi ()', 'fontsize',14);
yh=ylabel('Normalized amplitude', 'fontsize',14);
title('Beam pattern','fontsize',14)
set(gca,'fontsize',12)
axis([-90 90 0 1])

disp('done 1')
pause

f=input('frequency?'); % Hz
w0=2*pi*f;
c=1500; %sound speed m/s
f2=f;

% L=input('n of receivers?') 
% d= 1;%%sensors spacing
% L2=L;
% l=1:L;
% r(l)=[(l-1)*d];
% rs=-r;
n0=sin(phi_0);
k0=w0/c*n0; %wave vector
tau0=k0*rs; %delays

fs=750; %sample frequency
NFFT=1024;
t=0:1/fs:NFFT/fs;

for n=1:NFFT
    x(n,l)=exp(j*(w0*t(n)-tau0(l))); %received signal with delay
end 
X=fft(x); 

[maxf indf]=max(X(:,1)); 
Xrs=X(indf,:);

fi=-90:90;
   for e=1:length(fi)
        %steering angle
        phi=fi(e)*pi/180;
        n=sin(phi);
        k=w0/c*n;
        tau=k*rs;
        Xss=exp(-j*tau);
	    B(e)=abs(Xrs*Xss');
        
   end

B_s=(B)/max(max(B));

%figure
hold on
plot(fi,B_s,'r','lineWidth',2)
xh=xlabel('\phi ()', 'fontsize',14);
yh=ylabel('Normalized amplitude', 'fontsize',14);
title('Beam pattern','fontsize',14)
set(gca,'fontsize',12)
axis([-90 90 0 1])

disp('done 2')
pause

f=input('frequency?'); % Hz
w0=2*pi*f;
c=1500; %sound speed m/s
f3=f;

% L=input('n of receivers?') 
% d= 1;% sqrt(2) %sensors spacing
% L3=L;
% l=1:L;
% r(l)=[(l-1)*d];
% rs=-r;
n0=sin(phi_0);
k0=w0/c*n0; %wave vector
tau0=k0*rs; %delays

fs=750; %sample frequency
NFFT=1024;
t=0:1/fs:NFFT/fs;

for n=1:NFFT
    x(n,l)=exp(j*(w0*t(n)-tau0(l))); %received signal with delay
end 

X=fft(x); 

[maxf indf]=max(X(:,1)); 
Xrs=X(indf,:);

fi=-90:90;
   for e=1:length(fi)
        %steering angle
        phi=fi(e)*pi/180;
        n=sin(phi);
        k=w0/c*n;
        tau=k*rs;
        Xss=exp(-j*tau);
	    B(e)=abs(Xrs*Xss');
        
   end

B_s=(B)/max(max(B));

%figure
hold on
plot(fi,B_s,'g','lineWidth',2)
xh=xlabel('\phi ()', 'fontsize',14);
yh=ylabel('Normalized amplitude', 'fontsize',14);
title('Beam pattern','fontsize',14)
set(gca,'fontsize',12)
axis([-90 90 0 1])

legend([num2str(f1),' Hz'],[num2str(f2),' Hz'],[num2str(f3),' Hz'], 'position',2)