%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Summer School StrongMAR - 2016
% Array Data Processing
% Paulo Santos 
% 29th June, 2016
% Frequency domain beamformer 3D
% Different hydrophone array configurations
% 
% pjsantos@ualg.pt
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%close all
clear all

fs=5000; %sampling freq
NFFT=1028; 

f=input('frequency?'); %signal frequency Hz
w0=2*pi*f;
c=1500; %m/s

%DOA of received signal
theta_s=input('azimuth angle?')
theta0=theta_s*pi/180; 
phi_s=input('elevation angle?')
phi0=phi_s*pi/180;
L=input('n of receivers?') 
d= 1;% sqrt(2) %spacing between sensors

l=1:L; %(9 sensors)
r(l)=[(l-1)*d];
%rs=[zeros(2,L);-r]; %location of sensors (z axis)
%rs=[r;zeros(2,L)]; %location of sensors (x axis)
%rs=[zeros(1,L);r;zeros(1,L)]; %location of sensors (y axis)

%%%%%%%planar xy (9 sensors)
% rs=[0  1  -1  0  0  2  0 -2  0
%     0  0   0  1 -1  0  2  0 -2
%     0  0   0  0  0  0  0  0  0];

%%%%%%%planar xz (9 sensors)
% rs=[0 1 -1  0  0  2  0 -2  0
%     0 0 0 0 0 0 0 0 0
%     0 0   0  1 -1  0  2  0 -2];

%%%%%%%cubic (8 sensors)
% rs=[0  1  0  0  1  1  1 0  
%      0  0   1  0  1  1 0  1 
%      0  0   0  1  0  1  1  1];
%  
 
n0=[-sin(theta0)*cos(phi0) -cos(theta0)*cos(phi0) -sin(phi0)];
k0=w0/c*n0; %wave vector
tau0=k0*rs; %delays

t=0:1/fs:NFFT/fs;

for n=1:NFFT
   x(n,l)=exp(j*(w0*t(n)-tau0(l))); %received signal with delay
end 

X=fft(x); %frequency domain signal

% figure
% plot(0:fs/NFFT:fs-1, abs(X))
% axis tight

[maxf indf]=max(X(:,1)); %(indf-1)*fs/NFFT=working frequency
Xrs=X(indf,:);
R=Xrs'*Xrs; %correlation matrix

%beamformer (steering)
teta=-180:180;
fi=-90:90;
for a=1:length(teta)
    for e=1:length(fi)
        % "steer"
        theta=teta(a)*pi/180;
        phi=fi(e)*pi/180;
        n=[-sin(theta)*cos(phi) -cos(theta)*cos(phi) -sin(phi)];
        k=w0/c*n;
        tau=k*rs;
        Xss=exp(-j*tau);
	    B(a,e)=abs(Xss*R*Xss');
     end
end

B_s=(B)/max(max(B));

figure
pcolor(teta,fi,B_s')
shading interp
colorbar
xh=xlabel('Azimuth angle ()','fontsize',14);
yh=ylabel('Elevation angle ()', 'fontsize',14);
set(gca,'fontsize',13)
title('DOA estimation','fontsize',13)

