%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Summer School StrongMAR - 2016
% Array Data Processing
% Paulo Santos 
% 29th June, 2016
% Power Spectrum
%
% Experimental Data - Makai 2005
% pjsantos@ualg.pt
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%SOURCE TB2, data acquired on JD264 (September 20th) by a 4-element VSA 

clear all
%close all

% Sensors
L=4;
d=.1;
l=1:L;
r(l)=[-(l-1)*d];
rn=[zeros(2,L);r]; %z axis

% Data Time = 0.5s for each minute, 22 samples (fs=48000)
minutoTB2=[27 63];

for m=1:length(minutoTB2)
  min=minutoTB2(m)
  matfile=['r2preprocTB2_min',num2str(min)]
  load(matfile);

  %%% Low-frequency (assumed ship's noise)
  ind_lf=find(f<1000);
   
%   figure
%   for i=1:length(p1(1,:))
%       plot(f(ind_lf),abs(p1(ind_lf,i)))
%       hold on
%       pause
%   end   
  
  figure
  plot(f(ind_lf),abs(p1(ind_lf,:)))
  title('Power spectrum - Low freq') 
  disp(':::Low Frequency:::')
  pause

%%% High-frequency Tones
  ind_hf=find(f>8000 & f<14000);
  
  figure
  plot(f(ind_hf),abs(p1(ind_hf,:)))
  title('Power spectrum - High freq')  
  disp(':::High Frequency:::')
  pause
  
  
end  